
typedef struct
{
  char *name;
  uchar *pos;
} uniq_obj_t;

typedef struct
{
  char *set;
  strmap_t *map;
} unique_t;

unique_t *unique_begin(char *set)
{
  unique_t *U;
  U= xallocz(sizeof(*U));
  U->map= strmap_new();
  U->set= xstrdup(set);
  return U;
}

void unique(unique_t *U, char *name, uchar *pos)
{
  uniq_obj_t *O;
  O= strmap_find(U->map, name);
  if (O)
     irror2(O->pos, pos, "%s %s was defined multiple times\n", U->set, name);
  O= xallocz(sizeof(*O));
  O->name= xstrdup(name);
  O->pos= pos;
  strmap_insert(U->map,O->name, O);
}

void unique_end(unique_t *U)
{
  uniq_obj_t *O;
  while((O=strmap_destroy(U->map))) { free(O->name); free(O); }
  free(U->map);
  free(U->set);
  free(U);
}
