

typedef struct
{
  strmap_t *map;
  int last;
  int count;
} simap_t;

simap_t *simap_new()
{
  simap_t *S;
  S= xallocz(sizeof(*S));
  S->map= strmap_new();
  return S;
}

int simap_getp(simap_t *S, char *name)
{
  sipair_t *P;
  P= strmap_find(S->map, name);
  if (P) return P->ival;
  P= xallocz(sizeof(*P));
  P->sval= xstrdup(name);
  P->ival= S->last++;
  strmap_insert(S->map, P->sval, P);
  S->count++;
  return P->ival;
}

static int compare_sipair_int(const void *a, const void *b)
{
  const sipair_t *A, *B;
  A= a;
  B= b;
  return A->ival - B->ival;
}

static int compare_sipair_str(const void *a, const void *b)
{
  const sipair_t *A, *B;
  A= a;
  B= b;
  return strcmp(A->sval, B->sval);
}

void simap_free(simap_t *S, sipair_t **P, int *N,int sort)
{
  sipair_t *R;
  sipair_t *V;
  int i;
  i= 0;
  R= xalloc(S->count * sizeof(sipair_t));
  while((V=strmap_destroy(S->map)))
  {
    R[i++]= *V;
    free(V);
  }
  free(S->map);
  switch(sort)
  {
  case 'I':
    qsort(R, S->count, sizeof(sipair_t), compare_sipair_int);
    break;
  case 'S':
    qsort(R, S->count, sizeof(sipair_t), compare_sipair_str);
    break;
  }
  *P= R;
  *N= S->count;
  free(S);
}
