

/**
  This collects things in breadth-first order
 **/
void collect_allkidget(kreen_t *S)
{
  size_t sz;
  ptrbuf_t *P;
  kreen_t *K;
  ptrbuf_t *SS;
  int i, j;
  kidget_t *W;

  P= ptrbuf_new(50);
  SS= ptrbuf_new(50);
  ptrbuf_put(SS, S);

  while((K=ptrbuf_get(SS)))
  {
    for(i=0;i<K->n_kidget;i++)
    {
      W= K->kidget[i];
      ptrbuf_put(P, W);
      if (W->klass!=GFXCLASS_PANEL) continue;
      for(j=0;j<W->n_sub;j++)
        ptrbuf_put(SS, W->sub[j]);
    }
  }
  ptrbuf_free(SS, NULL, NULL);

  ptrbuf_free(P, (void***) &S->allkidget, &sz);
  S->n_allkidget= sz;
}

/** 
  sets the global_name and parent_index fields of kidgets
  contained in the kreen. parent_index is always relative to 
  the topmost kreen. 
 **/
int enumerate_kidgets_in_kreen(kreen_t *S, int wno)
{
  int i;
  kidget_t *W;
  for(i=0;i<S->n_allkidget;i++)
  {
    W= S->allkidget[i];
    W->global_name= wno;
    if (W->klass==GFXCLASS_PIXGRID) wno += GFXEV_LAST;
                               else wno += 1;
    W->index_in_parent= i;
  }
  return wno;
}

void enumerate_kidgets(input_t *ipt)
{
  int i;
  kreen_t *S;
  ipt->last_kidget_no= ipt->first_kidget_no= GFXEV_LAST+GFXRESERVED+1;
  for(i=0;i<ipt->n_kreen;i++)
  {
    S= ipt->kreen[i];
    collect_allkidget(S);
    ipt->last_kidget_no= enumerate_kidgets_in_kreen(S, ipt->last_kidget_no);
  }
}
