
void check_png_loadable(char *path)
{
  unsigned int Ow, Oh;
  uchar *Odata;
  unsigned int R;
  R= lodepng_decode32_file(&Odata, &Ow, &Oh, path); 
  if (R)                                                                        
    die("PNG_Decode(%s): %s\n", path, lodepng_error_text(R));
  free(Odata);                                                                  
}

static void gen_icon_file
  (struct byco *out, int icon_idx, int img_idx, iconfile_t *icon, uchar *pos)
{
  int file_size;
  char *path;

  path= path_sibling(get_pos_ifile(pos), icon->file);
  file_size= byco_file_blob(out, path);

  check_png_loadable(path);
  free(path);

  byco_int(out, file_size);
  byco_int(out, icon->dpi);
  byco_int(out, img_idx);
  byco_int(out, icon_idx);
  byco_op(out, GUII_ICONIMAGE);
}

static void gen_icon(struct byco *out,int idx, icondef_t *ID)
{
  int i;
  byco_int(out, ID->n_file);
  byco_int(out, idx);
  byco_op(out, GUII_ICON);
  for(i=0;i<ID->n_file;i++)
     gen_icon_file(out, idx, i, ID->file[i], ID->pos);
}

void gen_icons(input_t *ipt)
{
  int i;
  unique_t *U;

  U= unique_begin("icon");
  for(i=0;i<ipt->n_icon;i++)
     unique(U, (char*) ipt->icon[i]->ident, ipt->icon[i]->pos);
  unique_end(U);

  byco_setg_i(ipt->code, GUIG_NICON, ipt->n_icon);
  for(i=0;i<ipt->n_icon;i++)
    gen_icon(ipt->code, i, ipt->icon[i]);
}
