
void output_section
   (struct byco *out, kreen_t *S, int section_id, struct byco *code)
{
  byco_int(out, byco_size(code) + 1); // add a DONE instruction
  byco_int(out, code->nvars);
  byco_int(out, S->number);
  byco_op(out, GUII_SECTION);
  byco_byte(out, section_id);
  byco_byco(out, code, 0);
  byco_op(out, GUII_DONE);
}

void output_kreen_info
   (struct byco *out, kreen_t *S)
{
  int i;
  for(i=0;i<S->n_allkidget;i++) byco_int(out, S->allkidget[i]->global_name);
  byco_int(out, S->n_allkidget);
  byco_op(out, GUII_INTARRAY);
  byco_int(out, S->n_kidget);
  byco_int(out, S->n_allkidget);
  byco_int(out, S->number);
  byco_op(out, GUII_SCRINFO);
}

void gen_main(input_t *ipt)
{
  struct byco *out;
  int i;
  kreen_t *S;

  out= ipt->code;
  byco_setg_s(out, GUIG_WINDOW_TITLE, ipt->o_window_title.value.strv);
  byco_setg_i(out, GUIG_WINDOW_WIDTH, ipt->o_window_width.value.intv);
  byco_setg_i(out, GUIG_WINDOW_HEIGHT, ipt->o_window_height.value.intv);
  byco_setg_i(out, GUIG_FIRST_WIDGET, ipt->first_kidget_no);
  byco_setg_i(out, GUIG_LAST_WIDGET, ipt->last_kidget_no);

  gen_icons(ipt);
  gen_fonts(ipt);

  byco_setg_i(out, GUIG_NGLOBAL, ipt->global->count);

  byco_int(out, byco_size(ipt->globals_code));
  byco_op(out, GUII_GLOBALS_SECTION);
  byco_byco(out, ipt->globals_code, 1);
  ipt->globals_code= NULL;

  byco_setg_i(out, GUIG_NSCREEN, ipt->n_kreen);
  for(i=0;i<ipt->n_kreen;i++)
  {
    S= ipt->kreen[i];
    output_kreen_info(out, S);
    output_section(out, S, GUISEC_SCREENDIM, S->slay);
    output_section(out, S, GUISEC_CONSTRUCTOR, S->wcon);
    output_section(out, S, GUISEC_WIDGETLAYOUT, S->wlay);
  }
}
