
static void check_toplevel_assign(expr_t *E)
{
  if (!is_assign(E))
     irror(E->pos, "assignment required in 'let' directive\n");
  if (!is_ident(E->sub[0], NULL))
     irror(E->pos, "top level assignments can only set global variables\n");
}

void eval_global(input_t *ipt)
{
  varset_t *G;
  econtext_t *C;
  int i;

  insert_system_globals(G=varset_new(at_global)); 

  for(i=0;i<ipt->n_assign;i++) check_toplevel_assign(ipt->assign[i]);

  record_assignments_in_context(
    NULL, 
    C= econtext_new(CON_GLOBAL, G, NULL),
    ipt->n_assign, ipt->assign,
    ipt->globals_code= byco_new()
  );

  ipt->global= G;
  ipt->globals_code->nvars= G->count;
  byco_op(ipt->globals_code, GUII_DONE);
}

