
void slay_compute(econtext_t *C, struct byco *code, uchar *pos,
                  int target, int arg1, int op, int arg2)
{
  value_t *T, *A1, *A2;
  T= con_lookup_scoord_nc(C, target);
  if (T) return ;
  A1= con_lookup_scoord_nc(C, arg1);
  A2= con_lookup_scoord_nc(C, arg2);
  if (!A1 || !A2) return ;

  T= con_lookup_scoord(C, target, pos); // now create the value
  T->state= vs_visited;
  eval_value(C, A1, code, 1);
  eval_value(C, A2, code, 1);
  access_value(T, 1, code);
  T->state= vs_known;
}


void eval_kreen_layout(kreen_t *S, varset_t *G)
{
  econtext_t *C;

  record_assignments_in_context(
      NULL,
      C= econtext_new(CON_SLAY, G, 0),
      S->n_eslay, S->eslay,
      S->slay= byco_new()
  );

  //
  // These trigger the computation of each dimension in case the
  // two required parameters are already known. For a kreen, we
  // have sensible defaults. Therefore, we don't need to force
  // their computation.
  //
  slay_compute(C, S->slay, S->pos, wc_width,  wc_right,  GUII_SUB, wc_left);
  slay_compute(C, S->slay, S->pos, wc_height, wc_bottom, GUII_SUB, wc_top);
  slay_compute(C, S->slay, S->pos, wc_left,   wc_right,  GUII_SUB, wc_width);
  slay_compute(C, S->slay, S->pos, wc_top,    wc_bottom, GUII_SUB, wc_height);

  S->slay->nvars= C->locals->count; // it's always 4, due to reasons
}
