

void construct_epilogue(kidget_t *W, int func, struct byco *B)
{
  byco_int(B, func);
  byco_int(B, W->global_name);
  byco_op(B, GUII_CONSTRUCT);
}


void construct_args(struct byco *B, bcarg_t *A, int n)
{
  int i;
  for(i=n-1;i>=0;i--)
  {
    switch(A[i].type)
    {
    case BC_INT: byco_int(B, A[i].Vint); break;
    case BC_FLO: byco_float(B, A[i].Vflo); break;
    case BC_STR: byco_str(B, A[i].Vstr); break;
    }
  }
}

int construct_simple(kidget_t *W, struct byco *B)
{
  static const iipair_t simple[]=
  {  
     { GFXCLASS_LOGVIEW,  GUIWC_LOGVIEW },
     { GFXCLASS_PIXGRID,  GUIWC_PIXGRID },
     { GFXCLASS_DIRLIST,  GUIWC_DIRLIST },
     { GFXCLASS_DROPDOWN, GUIWC_DROPDOWN },
     { GFXCLASS_LIST,     GUIWC_LIST },
     {  -1,  -1 }
  };
  int kname;
  kname= iipair_lookup_a(simple, W->klass);
  if (kname<0)
     return 0;
  construct_epilogue(W, kname, B);
  return 1;
}



static void construct_panel(kreen_t *S, kidget_t *W, struct byco *B)
{
  int sa, i, j;
  kreen_t *U;

  sa= 0;  // size of array 
  
  byco_int(B,W->n_sub); sa++;

  for(i=0;i<W->n_sub;i++)
  {
    U= W->sub[i];
    byco_int(B, U->n_kidget); sa++;
    for(j=0;j<U->n_kidget;j++)
    {
      byco_int(B, U->kidget[j]->global_name); sa++;
    }
  }
  byco_int(B, sa);
  byco_op(B, GUII_INTARRAY);
 
  construct_epilogue(W, GUIWC_PANEL, B);
}

void construct_kidget(input_t *ipt, kreen_t *S, kidget_t *W, struct byco *B)
{
  bcarg_t A[20]; 
  int n;
  int func;

  static const sipair_t spinner_types[]={
    { "integer", 'I' },
    { "float",  'F' },
    { NULL, -1 }};

  if (construct_simple(W,B)) return ;

  n= 0;
  switch(W->klass)
  {
  case GFXCLASS_LABEL:
    func= GUIWC_LABEL; 
    A[n++]= wa_int(W,"font",1);
    A[n++]= wa_int(W,"fg", 0);
    A[n++]= wa_int(W,"bg", 0xededed);
    A[n++]= wa_justify(W, 'C'); 
    A[n++]= wa_text(W, "");
    break;
  case GFXCLASS_PROGRESSBAR:
    func= GUIWC_PROGRESSBAR;
    A[n++]= wa_int(W,"font",1);
    A[n++]= wa_int(W,"fg",0x00);
    A[n++]= wa_int(W,"bg",0xededed);
    A[n++]= wa_int(W,"fill", 0xcc);
    break;
  case GFXCLASS_BUTTON:
    func= GUIWC_BUTTON; 
    A[n++]= wa_text(W,"");
    A[n++]= wa_iconpos(W, 'T');
    A[n++]= wa_icon(ipt, W,-1);
    A[n++]= bcINT(GFXCLASS_BUTTON);
    break;
  case GFXCLASS_TOGGLE:
    func= GUIWC_BUTTON;
    A[n++]= wa_text(W,"");
    A[n++]= wa_iconpos(W,'T');
    A[n++]= wa_icon(ipt, W,-1);
    A[n++]= bcINT(GFXCLASS_TOGGLE);
    break;
  case GFXCLASS_CHECKBOX:
    func= GUIWC_CHECKBOX;
    A[n++]= wa_text(W,"");
    break;
  case GFXCLASS_FILELIST:
    func= GUIWC_FILELIST;
    A[n++]= wa_bool(W, "types", 1);
    A[n++]= wa_bool(W, "hidden", 1);
    break;
  case GFXCLASS_TEXTENTRY:
    func= GUIWC_TEXTENTRY;
    A[n++]= wa_text(W, "");
    break;
  case GFXCLASS_SCROLLBAR:
    func= GUIWC_SCROLLBAR;
    A[n++]= wa_bool(W, "vertical", 0);
    A[n++]= wa_float(W, "start", 0.0); 
    A[n++]= wa_float(W, "end", 1.0);
    A[n++]= wa_float(W, "step", 0.1);
    break;
  case GFXCLASS_ICONLIST:
    func= GUIWC_ICONLIST;
    A[n++]= wa_int(W, "fg",   0);
    A[n++]= wa_int(W, "bg",   0xffffff);
    A[n++]= wa_int(W, "vpad", 10);
    A[n++]= wa_int(W, "hpad", 10);
    A[n++]= wa_int(W, "max_text_width", 150);
    A[n++]= wa_bool(W, "multi_select", 0);
    break;
  case GFXCLASS_SLIDER:
    func= GUIWC_SLIDER;
    A[n++]= wa_orient(W, 'H');
    break;
  case   GFXCLASS_CANVAS:
    func= GUIWC_CANVAS;
    A[n++]= wa_bool(W, "horscroll", 1);
    A[n++]= wa_bool(W, "verscroll", 1);
    break;
  case GFXCLASS_RADIO: 
    func= GUIWC_RADIO;
    A[n++]= wa_text(W, "");
    A[n++]= wa_kidget_id(S, W, "group", W->global_name);
    break;
  case GFXCLASS_SPINNER:
    func= GUIWC_SPINNER;
    A[n++]= wa_enum(W, "type", spinner_types, 'I');
    A[n++]= wa_int(W, "fraction", 3);
    break;
  case   GFXCLASS_PANEL: construct_panel(S, W, B); return;
  } 

  construct_args(B, A, n);
  construct_epilogue(W, func, B);
}

void eval_kidget_ctor(input_t *ipt, kreen_t *S)
{
  int i;
  S->wcon= byco_new();
  for(i=0;i<S->n_allkidget;i++)
    construct_kidget(ipt, S, S->allkidget[i], S->wcon);
}
