
// continuing from library-data.c
 {NULL }
};

#define OUT_BUFFER_SIZE 40960


static int decompress_code(const unsigned char *inp, int len, out_t *out)
{
  int R;
  size_t olen;
  mz_stream MZ;
  size_t done;
  unsigned char outbuffer[OUT_BUFFER_SIZE];

  memset(&MZ, 0, sizeof(MZ));
  MZ.next_in= inp;
  MZ.avail_in= len;
  MZ.next_out= outbuffer;
  MZ.avail_out= OUT_BUFFER_SIZE;
  done= 0;

  mz_inflateInit(&MZ);
  do {
    R= mz_inflate(&MZ, MZ_NO_FLUSH );
    olen= OUT_BUFFER_SIZE - MZ.avail_out;
    if (olen) owrite(out, outbuffer,olen);
    done+= olen;
    MZ.next_out= outbuffer;
    MZ.avail_out= OUT_BUFFER_SIZE;
    if (R!=MZ_OK && R!=MZ_STREAM_END) 
    {
      fprintf(stderr,"mz error: %d\n", R); 
      fprintf(stderr,"done so far: %d\n", (int) done);
      fprintf(stderr,"input consumed: %d\n", (int) (MZ.next_in - inp));
      break;
    }
  } while(R!=MZ_STREAM_END);
  mz_inflateEnd(&MZ);
  return 0;
}


int print_code_component(const char *name, out_t *out)
{
  int i;
  for(i=0;code_components[i].name;i++)
  {
    if (!strcmp(name,code_components[i].name)) 
    {
      decompress_code(code_components[i].data, code_components[i].len, out);
      return 0;
    }
  }
  return 1;
}

