
void handle_trivial_options(char *pname)
{
  if (prg.v)
  {
    printf("%d.%d\n", GFX_VMAJOR, GFX_VMINOR);
    exit(0);
  }
  if (prg.h) print_options_help(pname, 0, 1);

  if (prg.help || prg.g)
    die("internal error: unimplemented options\n");
}

static input_t *conditional_parse(int argc, char **argv)
{
  input_t *ipt;
  // only these options require an input
  if (prg.dc || prg.dh || prg.cc || prg.ch || prg.lc || prg.lh || prg.d  || prg.t  || prg.T)
  {
    if (argc!=2) 
    {
      fprintf(stderr,"%s: exactly one input file is required\n", argv[0]);
      print_options_help(argv[0], 1,1);
    }
    ipt= parse_file(argv[1]);
    return ipt;
  }
  return NULL;
}

void disassemble(input_t *ipt)
{
  struct byco_ptr *P;
  int sz, i;
  uchar buf[2000];
  dis_t *D;
  P= byco_read_start(ipt->code);
  D= d_init(stdout);
  while ((sz=byco_read(P, buf, sizeof(buf))))
  {
    for(i=0;i<sz;i++) d_byte(D, buf[i]);
  }
  byco_read_end(P);
  d_done(D);
}

int main(int argc, char **argv)
{
  input_t *ipt;
  outset_t *os;

  parse_program_options(&argc, argv);
  handle_trivial_options(argv[0]);
  ipt= conditional_parse(argc, argv);

  if (prg.t || prg.T)
  {
    imake_test_screen(ipt);
  }
  
  if (ipt)
  {
    init_input(ipt);
    record_file_options(ipt);
    compile_input(ipt);
  }

  if (prg.t || prg.T)
  {
    test_input(ipt, prg.t ? prg.t : NULL);
  }

  if (prg.d) { disassemble(ipt); exit(0); }

  os= make_outset();
  if (ipt && os)
  {
    output_library_header(os);
    output_data_header(ipt, os);
    output_library_source(ipt,os);
    output_data_source(ipt,os);
    close_outset(os);
  }

  return 0;
}

