
#ifndef GFX_WIN
#define GFX_UNIX
#endif

#ifdef GFX_WIN
#undef GFX_WIN 
#define GFX_WIN 1
#endif
#ifdef GFX_X11
#undef GFX_X11
#define GFX_X11 1
#endif
#ifdef GFX_FB
#undef GFX_FB
#define GFX_FB 1
#endif
#ifdef GFX_ANDROID
#undef GFX_ANDROID
#define GFX_ANDROID 1
#endif
#if (GFX_WIN + GFX_X11 + GFX_FB + GFX_ANDROID != 1)
#error "exactly one of GFX_WIN, GFX_X11, GFX_FB or GFX_ANDROID must be defined"
#endif

#ifdef GFX_WIN
#include <windows.h>
#include <windowsx.h>
#include <malloc.h>
#define quad_t int64_t
#define u_quad_t uint64_t
#define ssize_t size_t
#pragma warning( disable : 4244 ) 
#pragma warning( disable : 4267 ) 
#pragma warning(disable:6011)
#pragma warning( disable : 26451 )

#endif

#define __USE_BSD 1
#include <sys/types.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <stdarg.h>
#include <ctype.h>
#include <errno.h>
#include <stdio.h>
#ifdef GFX_UNIX
#include <unistd.h>
#endif
#ifdef GFX_X11
#include <stdarg.h>
#include <stdint.h>
#include <alloca.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include <dirent.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/XShm.h>
#include <X11/extensions/Xrandr.h>
#include <X11/Xatom.h>
#include <X11/Xlocale.h>
#include <X11/Xos.h>
#include <X11/Xproto.h>
#define XK_MISCELLANY
#include <X11/keysymdef.h>
#endif

#ifdef GFX_FB
#include <stdarg.h>
#include <stdint.h>
#include <alloca.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <termios.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <dirent.h>
#include <linux/input.h>
#include <linux/fb.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <fcntl.h>
#endif

#ifdef GFX_ANDROID
#include <jni.h>
#include <stdlib.h>
#include <alloca.h>
#include <stdio.h>
#include <math.h>
#include <stdint.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <sys/resource.h>
#include <poll.h>
#include <pthread.h>
#include <sched.h>
#include <android/configuration.h>
#include <android/looper.h>
#include <android/native_activity.h>
#include <android/window.h>
#include <android/log.h>
#include <android/input.h>
#include <android/keycodes.h>

#define quad_t int64_t
#define u_quad_t uint64_t


#ifdef GFX_ANDROID_RELEASE
#define logg(...)  ((void)0)
#endif

#endif   // GFX_ANDROID
