
#define DOCB_HEADING        1
#define DOCB_PARAGRAPH      2
#define DOCB_LIST           3
#define DOCB_SOURCE         4
#define DOCB_IMAGE          5
#define DOCB_MATH           6

typedef struct doctext DOCT;
typedef struct docattr DOCA;
typedef struct docitem DOCI;
typedef struct docline DOCL;
typedef struct docblock DOCB;

typedef struct { DOCA *data; int n; } DOCAL;
typedef struct { DOCT *data; int n; } DOCTL;
typedef struct { DOCI *data; int n; } DOCIL;
typedef struct { DOCL *data; int n; } DOCLL;
typedef struct { DOCB *data; int n; } DOCBL;

struct docattr
{
  char *name;
  char *value;
};

struct doctext
{
  enum { DOCT_DIRECT, DOCT_ATTR } type;
  union {
    struct {
     DOCAL att;
     DOCTL text;
    };
    char *str;
  };
};

struct docline
{
  DOCTL text;
};

struct docblock
{
  int type;
  union
  {
    int hlevel;      // heading
    DOCIL item;      // lists
  };
  union
  {
    DOCTL text;     // for heading and paragraph
    DOCLL line;     // for code
  };
  DOCAL att;
};

struct docitem {    // list item
  DOCTL text;
};


typedef struct
{
  DOCBL block;
} DOC;


