
typedef struct pnode pnode_t;

typedef struct { pnode_t *data; int n; } PNODEL;

struct pnode
{
  int type;
  uint64_t pos;
  union {
    char *data;
    PNODEL child;
  };
};

void parse_title(parser_t *P, char *line, uint64_t pos)
{
  int n;
  trim_begin(line);
  n= trim_chars_begin(line,'=');
  trim_begin(line);
  trim_end(line);
  trim_chars_end(line,'=');
  trim_end(line);
  for(n=0;line[n]=='=';n++) ;
  line+= n;
}

void parse_cmd
   (char *line, int n, char **cmd,
    int *Rn, char **name, char **value, char **rest)
{
  parse_word(line, cmd);
}

DOC *parse_file(char *fn)
{
  char *line;
  uint64_t pos;
  include_input(fn);
  while(ifile_get_line(&line, &pos))
  {
    switch(classify_line(line,pos))
    {
    case DOCLINE_TITLE:
       parse_title(DD, line, pos);
       break;
    case DOCLINE_LIST:
       parse_list_item(DD, line, pos);
       break;
    case DOCLINE_CODEB:
       break;
    case DOCLINE_CODEE:
       irror(pos, "unmatched code-end\n");
       break;
    case DOCLINE_PARA:
       parse_para(DD, line, pos);
       break;
    }
  }
}
