#include <stdio.h>

enum { LINE_LINKDEF,
       LINE_TITLE,
       LINE_SUBTIT,
       LINE_PARA,
       LINE_CODES,
       LINE_CODEF };

int ispc(char *s)
{
  unsigned char x= *(unsigned char*) s;
  return  (x>0 && x<33) || (x==127);
}

char *trim_head(char *line)
{
  while(ispc(line)) line++;
  return line;
}

void trim_tail(char *line)
{
  int L;
  for(L=strlen(line)-1;L>=0 && ispc(line+L);L--)
    line[L]= 0;
}

int allcaps(char *line)
{
  int i;
  for(i=0;line[i];i++)
    if (line[i]>='a' && line[i]<='z') return 0;
  return 1;
}

int classify_line(char *line)
{
  trim_tail(line=trim_head(line));
  if (line[0]=='@') return LINE_LINKDEF;
  if (haspfx(line,"---")) return LINE_SUBTIT;
  if (!strcmp(line,"[")) return LINE_CODES;
  if (!strcmp(line,"]")) return LINE_CODEF;
  if (allcaps(line)) return LINE_TITLE;
  return LINE_PARA;
}

enum { LCO_REGULAR, LCO_LINK, LCO_BOLD };
typedef struct lcomp {
  int type;
  char *data;
};

void mkbase64_out(unsigned char *out)
{
  int i;
  memset(out, 0, sizeof(out));
  for(i='A';i<='Z';i++) out[i]= i;
  for(i='a';i<='z';i++) out[i]= i+26;
  for(i='0';i<='9';i++) out[i]= i+52;
  out['+']= 62;
  out['/']= 63;
}

void mkbase64_in(unsigned char *in)
{
  int i;
  unsigned char out[256];
  mkbase64_out(out);
  for(i=0;i<256;i++) in[out[i]]= i;
  in[0]= 'A';
}

char* read_line(FILE *f)
{
  char buf[2000];
  if (!fgets(buf, sizeof(buf), f)) return NULL;
  buf[sizeof(buf)-1]= 0;
  trim_tail(buf);
  return strdup(buf);
}

/**
 **/

int main(int argc, char **argv)
{
  FILE *f;
  char *line;
  
  f= open_force(argv[1], "rb");
  while((line=read_line(f)))
  {
    switch(classify_line(line)))
    {
    }
  }
  fclose(f);
  
}
